<?php
/*
Plugin Name: Christina's Twitter in Widget
Plugin URI: http://www.ie.u-ryukyu.ac.jp/~e065708/wp_plugins/index.html
Description: Show Twitter in Widget space
Author: Christina U
Version: 0.1
Author URI: http://twitter.com/ucc_tina/
*/

class CTwitterWidget extends WP_Widget {
    function CTwitterWidget() {
      $widget_ops = array(
        'description' => 'This is a simple widget to show Twitter in sidebars and more'
	);
      parent::WP_Widget(false, $name = 'CTwitter',$widget_ops);
    }

    function widget($args, $instance) {
      extract($args);
      $twitterid = apply_filters('widget_title', $instance['twitterid'] );
      $tweetnum = apply_filters('widget_title', $instance['tweetnum']);
      $background = apply_filters('widget_title', $instance['background']);
      $color = apply_filters('widget_title', $instance['color']);
      $tweetback = apply_filters('widget_title', $instance['tweetback']);
      $tweetcolor = apply_filters('widget_title', $instance['tweetcolor']);
      $tweetlinks = apply_filters('widget_title', $instance['tweetlinks']);
      echo $before_widget;
      if( $twitterid ) { ?>
<script src="http://widgets.twimg.com/j/2/widget.js"></script>
<script>
	  new TWTR.Widget({
	    version: 2,
		type: 'profile',
		rpp: <?php echo $tweetnum ?>,
		interval: 6000,
		width: 'auto',
		height: 300,
		theme: {
	      shell: {
		background: '<?php echo $background; ?>',
		    color: '<?php echo $color ?>'
		    },
		  tweets: {
		background: '<?php echo $tweetback ?>',
		    color: '<?php echo $tweetcolor?>',
		    links: '<?php echo $tweetlinks ?>'
		    }
	      },
		features: {
	      scrollbar: false,
		  loop: false,
		  live: false,
		  hashtags: true,
		  timestamp: true,
		  avatars: false,
		  behavior: 'all'
		  }
	    }).render().setUser('<?php echo $twitterid; ?>').start();
</script>
<?php } //end twitter
      echo $after_widget;
    }

    function update($new_instance, $old_instance) {
      $instance = $old_instance;
      $instance['twitterid'] = strip_tags($new_instance['twitterid']);
      $instance['tweetnum'] = strip_tags($new_instance['tweetnum']);
      $instance['background'] = strip_tags($new_instance['background']);
      $instance['color'] = strip_tags($new_instance['color']);
      $instance['tweetback'] = strip_tags($new_instance['tweetback']);
      $instance['tweetcolor'] = strip_tags($new_instance['tweetcolor']);
      $instance['tweetlinks'] = strip_tags($new_instance['tweetlinks']);
      return $instance;
    }

    function form($instance) {
      echo '<div>twitter ID:<br /><input name="' . $this->get_field_name('twitterid') . '" type="text" value="' . $instance['twitterid'] . '" /></div>';
      echo '<div>表示数:<br /><input name="' . $this->get_field_name('tweetnum') . '" type="text" value="' . $instance['tweetnum'] . '" /></div>';
      echo '<div>ヘッダ背景色:<br /><input name="' . $this->get_field_name('background') . '" type="text" value="' . $instance['background'] . '" /></div>';
      echo '<div>ヘッダ文字色:<br /><input name="' . $this->get_field_name('color') . '" type="text" value="' . $instance['color'] . '" /></div>';
      echo '<div>ボディ背景色:<br /><input name="' . $this->get_field_name('tweetback') . '" type="text" value="' . $instance['tweetback'] . '" /></div>';
      echo '<div>ボディ文字色:<br /><input name="' . $this->get_field_name('tweetcolor') . '" type="text" value="' . $instance['tweetcolor'] . '" /></div>';
      echo '<div>リンク色:<br /><input name="' . $this->get_field_name('tweetlinks') . '" type="text" value="' . $instance['tweetlinks'] . '" /></div>';
    }
}

add_action('widgets_init', create_function('', 'return register_widget("CTwitterWidget");'));
?>